The ESAPI function for the TPM2_Import command.
Enhanced System API » Esys TPM Commands

## Functions

TSS2_RC | Esys_Import_Async (ESYS_CONTEXT *esysContext, ESYS_TR parentHandle, ESYS_TR shandle1, ESYS_TR shandle2, ESYS_TR shandle3, const TPM2B_DATA *encryptionKey, const TPM2B_PUBLIC *objectPublic, const TPM2B_PRIVATE *duplicate, const TPM2B_ENCRYPTED_SECRET *inSymSeed, const TPMT_SYM_DEF_OBJECT *symmetricAlg)
TSS2_RC | Esys_Import (ESYS_CONTEXT *esysContext, ESYS_TR parentHandle, ESYS_TR shandle1, ESYS_TR shandle2, ESYS_TR shandle3, const TPM2B_DATA *encryptionKey, const TPM2B_PUBLIC *objectPublic, const TPM2B_PRIVATE *duplicate, const TPM2B_ENCRYPTED_SECRET *inSymSeed, const TPMT_SYM_DEF_OBJECT *symmetricAlg, TPM2B_PRIVATE **outPrivate)
TSS2_RC | Esys_Import_Finish (ESYS_CONTEXT *esysContext, TPM2B_PRIVATE **outPrivate)

## Detailed Description

ESAPI function to invoke the TPM2_Import command either as a one-call or in an asynchronous manner.

## Function Documentation

## Esys_Import()

TSS2_RC Esys_Import | ( | ESYS_CONTEXT * | esysContext,
|  | ESYS_TR | parentHandle,
|  | ESYS_TR | shandle1,
|  | ESYS_TR | shandle2,
|  | ESYS_TR | shandle3,
|  | const TPM2B_DATA * | encryptionKey,
|  | const TPM2B_PUBLIC * | objectPublic,
|  | const TPM2B_PRIVATE * | duplicate,
|  | const TPM2B_ENCRYPTED_SECRET * | inSymSeed,
|  | const TPMT_SYM_DEF_OBJECT * | symmetricAlg,
|  | TPM2B_PRIVATE ** | outPrivate )

One-Call function for TPM2_Import

This function invokes the TPM2_Import command in a one-call variant. This means the function will block until the TPM response is available. All input parameters are const. The memory for non-simple output parameters is allocated by the function implementation.

Parameters

  [in,out] | esysContext | The ESYS_CONTEXT.
  [in] | parentHandle | The handle of the new parent for the object.
  [in] | shandle1 | Session handle for authorization of parentHandle
  [in] | shandle2 | Second session handle.
  [in] | shandle3 | Third session handle.
  [in] | encryptionKey | The optional symmetric encryption key used as the inner wrapper for duplicate.
  [in] | objectPublic | The public area of the object to be imported.
  [in] | duplicate | The symmetrically encrypted duplicate object that may contain an inner symmetric wrapper.
  [in] | inSymSeed | The seed for the symmetric key and HMAC key.
  [in] | symmetricAlg | Definition for the symmetric algorithm to use for the inner wrapper.
  [out] | outPrivate | The sensitive area encrypted with the symmetric key of parentHandle. (callee-allocated)

Return values

  TSS2_RC_SUCCESS | if the function call was a success.
  TSS2_ESYS_RC_BAD_REFERENCE | if the esysContext or required input pointers or required output handle references are NULL.
  TSS2_ESYS_RC_BAD_CONTEXT | if esysContext corruption is detected.
  TSS2_ESYS_RC_MEMORY | if the ESAPI cannot allocate enough memory for internal operations or return parameters.
  TSS2_ESYS_RC_BAD_SEQUENCE | if the context has an asynchronous operation already pending.
  TSS2_ESYS_RC_INSUFFICIENT_RESPONSE | if the TPM's response does not at least contain the tag, response length, and response code.
  TSS2_ESYS_RC_MALFORMED_RESPONSE | if the TPM's response is corrupted.
  TSS2_ESYS_RC_RSP_AUTH_FAILED | if the response HMAC from the TPM did not verify.
  TSS2_ESYS_RC_MULTIPLE_DECRYPT_SESSIONS | if more than one session has the 'decrypt' attribute bit set.
  TSS2_ESYS_RC_MULTIPLE_ENCRYPT_SESSIONS | if more than one session has the 'encrypt' attribute bit set.
  TSS2_ESYS_RC_BAD_TR | if any of the ESYS_TR objects are unknown to the ESYS_CONTEXT or are of the wrong type or if required ESYS_TR objects are ESYS_TR_NONE.
  TSS2_RCs | produced by lower layers of the software stack may be returned to the caller unaltered unless handled internally.

## Esys_Import_Async()

TSS2_RC Esys_Import_Async | ( | ESYS_CONTEXT * | esysContext,
|  | ESYS_TR | parentHandle,
|  | ESYS_TR | shandle1,
|  | ESYS_TR | shandle2,
|  | ESYS_TR | shandle3,
|  | const TPM2B_DATA * | encryptionKey,
|  | const TPM2B_PUBLIC * | objectPublic,
|  | const TPM2B_PRIVATE * | duplicate,
|  | const TPM2B_ENCRYPTED_SECRET * | inSymSeed,
|  | const TPMT_SYM_DEF_OBJECT * | symmetricAlg )

Asynchronous function for TPM2_Import

This function invokes the TPM2_Import command in a asynchronous variant. This means the function will return as soon as the command has been sent downwards the stack to the TPM. All input parameters are const. In order to retrieve the TPM's response call Esys_Import_Finish.

Parameters

  [in,out] | esysContext | The ESYS_CONTEXT.
  [in] | parentHandle | The handle of the new parent for the object.
  [in] | shandle1 | Session handle for authorization of parentHandle
  [in] | shandle2 | Second session handle.
  [in] | shandle3 | Third session handle.
  [in] | encryptionKey | The optional symmetric encryption key used as the inner wrapper for duplicate.
  [in] | objectPublic | The public area of the object to be imported.
  [in] | duplicate | The symmetrically encrypted duplicate object that may contain an inner symmetric wrapper.
  [in] | inSymSeed | The seed for the symmetric key and HMAC key.
  [in] | symmetricAlg | Definition for the symmetric algorithm to use for the inner wrapper.

Return values

  ESYS_RC_SUCCESS | if the function call was a success.
  TSS2_ESYS_RC_BAD_REFERENCE | if the esysContext or required input pointers or required output handle references are NULL.
  TSS2_ESYS_RC_BAD_CONTEXT | if esysContext corruption is detected.
  TSS2_ESYS_RC_MEMORY | if the ESAPI cannot allocate enough memory for internal operations or return parameters.
  TSS2_RCs | produced by lower layers of the software stack may be returned to the caller unaltered unless handled internally.
  TSS2_ESYS_RC_MULTIPLE_DECRYPT_SESSIONS | if more than one session has the 'decrypt' attribute bit set.
  TSS2_ESYS_RC_MULTIPLE_ENCRYPT_SESSIONS | if more than one session has the 'encrypt' attribute bit set.
  TSS2_ESYS_RC_BAD_TR | if any of the ESYS_TR objects are unknown to the ESYS_CONTEXT or are of the wrong type or if required ESYS_TR objects are ESYS_TR_NONE.

## Esys_Import_Finish()

TSS2_RC Esys_Import_Finish | ( | ESYS_CONTEXT * | esysContext,
|  | TPM2B_PRIVATE ** | outPrivate )

Asynchronous finish function for TPM2_Import

This function returns the results of a TPM2_Import command invoked via Esys_Import_Finish. All non-simple output parameters are allocated by the function's implementation. NULL can be passed for every output parameter if the value is not required.

Parameters

  [in,out] | esysContext | The ESYS_CONTEXT.
  [out] | outPrivate | The sensitive area encrypted with the symmetric key of parentHandle. (callee-allocated)

Return values

  TSS2_RC_SUCCESS | on success
  ESYS_RC_SUCCESS | if the function call was a success.
  TSS2_ESYS_RC_BAD_REFERENCE | if the esysContext or required input pointers or required output handle references are NULL.
  TSS2_ESYS_RC_BAD_CONTEXT | if esysContext corruption is detected.
  TSS2_ESYS_RC_MEMORY | if the ESAPI cannot allocate enough memory for internal operations or return parameters.
  TSS2_ESYS_RC_BAD_SEQUENCE | if the context has an asynchronous operation already pending.
  TSS2_ESYS_RC_TRY_AGAIN | if the timeout counter expires before the TPM response is received.
  TSS2_ESYS_RC_INSUFFICIENT_RESPONSE | if the TPM's response does not at least contain the tag, response length, and response code.
  TSS2_ESYS_RC_RSP_AUTH_FAILED | if the response HMAC from the TPM did not verify.
  TSS2_ESYS_RC_MALFORMED_RESPONSE | if the TPM's response is corrupted.
  TSS2_RCs | produced by lower layers of the software stack may be returned to the caller unaltered unless handled internally.